var app = require('http').createServer()

var io = require('socket.io')(app);

var port = 8080;
app.listen(port);

console.log('app listen at '+port)

let users = [];

io.on('connection', function(socket){
    let isNewPerson = true;
    let username = null;

    socket.on('login', function(data){
        for(var i=0; i<users.length; i++){
            isNewPerson = (users[i].username === data.username)? false : true;
        }
        if(isNewPerson){
            username = data.username
            users.push({
                username: data.username
            })
            data.userCount = users.length
            socket.emit('loginSuccess', data)
            io.sockets.emit('add', data)
        }else{
            socket.emit('loginFail', '')
        }
    })

    socket.on('logout', function(){

        socket.emit('leaveSuccess')
        users.map(function(val, index){
            if(val.username === username){
                users.splice(index, 1);
            }
        })
        io.sockets.emit('leave', {username: username, userCount: users.length})
    })

    socket.on('sendMessage', function(data){
        console.log(data)
        io.sockets.emit('receiveMessage', data)
    })
})